using System;
using System.Data;
using System.Web;
using System.Threading;
using System.Collections;
using com.common.DAL;
using com.common.util;
using com.common.classes;
using com.ties.DAL;
using com.ties.classes;
using System.Text;

namespace com.ties.BAL
{
	/// <summary>
	/// Summary description for InvoiceJobMgrBAL.
	/// </summary>
	public class InvoiceJobMgrBAL
	{
		JobStatusInfo		m_jobStatusInfo;
		InvoiceStatusInfo	m_invoiceStatusInfo;
		DataSet				m_dsInvoiceCriteria;
		String				m_strAppID = null;
		String				m_strEnterpriseID = null;
		String				m_mbg = "N";
		String strMsgCom = "";
		String strMsgTot = "";

		public InvoiceJobMgrBAL()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public JobStatusInfo AllocateInvoiceJob(String strAppID, String strEnterpriseID, DataSet dsInvoiceCriteria, long iJobID, HttpContext context, Utility utility)
		{
			//Step 1 :	Begin a database transcation
			//long iJobID = 0;

			m_strAppID		= strAppID;
			m_strEnterpriseID	= strEnterpriseID;
			m_dsInvoiceCriteria = dsInvoiceCriteria;

			DbConnection dbConApp = null;
			IDbTransaction transactionApp = null;
			IDbConnection conApp = null;

			//Get App dbConnection
			dbConApp = DbConnectionManager.GetInstance().GetDbConnection(m_strAppID,m_strEnterpriseID);

			if(dbConApp == null)
			{
				Logger.LogTraceError("InvoiceJobMgrBAL","AllocateInvoiceJob","SDM002","dbConApp is null");
				throw new ApplicationException("Connection to Database failed",null);
			}

			//Begin Core and App Transaction
			conApp = dbConApp.GetConnection();
			
			if(conApp == null)
			{
				Logger.LogTraceError("InvoiceJobMgrBAL","AllocateInvoiceJob","SDM002","conApp is null");
				throw new ApplicationException("Connection to Database failed",null);
			}

			try
			{
				dbConApp.OpenConnection(ref conApp);
			}
			catch(ApplicationException appException)
			{
				if(conApp != null)
				{
					conApp.Close();
				}
				Logger.LogTraceError("InvoiceJobMgrBAL","AllocateInvoiceJob","SDM003","Error opening connection : "+ appException.Message.ToString());
				throw new ApplicationException("Error opening database connection ",appException);
			}
			catch(Exception exception)
			{
				if(conApp != null)
				{
					conApp.Close();
				}

				Logger.LogTraceError("InvoiceJobMgrBAL","AllocateInvoiceJob","SDM003","Error opening connection : "+ exception.Message.ToString());
				throw new ApplicationException("Error opening database connection ",exception);
			}


			transactionApp = dbConApp.BeginTransaction(conApp,IsolationLevel.ReadCommitted);


			if(transactionApp == null)
			{
				Logger.LogTraceError("InvoiceJobMgrBAL","AllocateInvoiceJob","SDM002","transactionApp is null");
				throw new ApplicationException("Failed Begining a App Transaction..",null);
			}

			//			If the job_status is not "In Progress" then
			//			-	Insert a new Job record with autogenerated jobid
			//			-	Start the new thread to execute the job
			//			-	Commit the transaction if the thread is spawned successfull
			//			-	Rollback the transaction if any error creating the transaction
			//			-	Show user message and return.
			try
			{
				//Step 2 :	Lock the Invoice_Generation_Task table and read the job_status
				DataSet dsJobStatus = InvoiceJobMgrDAL.GetInvoiceJobStatusDS(dbConApp, transactionApp, conApp,m_strAppID, m_strEnterpriseID);
				
				int iNumRows = dsJobStatus.Tables[0].Rows.Count;

				if(iNumRows > 0)
				{
					m_jobStatusInfo = new JobStatusInfo();
					DataRow drCurrent = dsJobStatus.Tables[0].Rows[0];

					m_jobStatusInfo.iJobID = (long) drCurrent["jobid"];
					m_jobStatusInfo.dtStartDateTime = (DateTime) drCurrent["start_datetime"];
					m_jobStatusInfo.strRemark = (String) drCurrent["remark"];
					m_jobStatusInfo.strJobStatusMessageID = "MCA_JOB_ALREADY_INPROGRESS";
					transactionApp.Rollback();
					
					//This job is in process
					//end transaction using rollback
					//Return the jobid which is in process
				}
				else
				{
					//Create a new job
					//Insert the the job record					
					m_jobStatusInfo = InvoiceJobMgrDAL.AddInvoiceJob(dbConApp,transactionApp,conApp,m_strAppID,m_strEnterpriseID);
					m_jobStatusInfo.strJobStatusMessageID = "INVOICE_GENERATION_JOB_STARTED";

					//Prepare messages
					if(!utility.GetUserCulture().ToUpper().Equals("EN-US"))
					{
						strMsgCom = Utility.GetLanguageText(ResourceType.ScreenLabel, "Job Completed Successfully", utility.GetUserCulture());
						strMsgTot = Utility.GetLanguageText(ResourceType.ScreenLabel, "Total No of Invoice(s)/Customer(s)/AWB(s) are", utility.GetUserCulture());
					} 
					else 
					{
						strMsgCom = "Job Completed Successfully";
						strMsgTot = "Total No of Invoice(s)/Customer(s)/AWB(s) are";
					}

					//Start the new job thread
					Thread invJobBatch = new Thread(new ThreadStart(this.Allocate));
					
					invJobBatch.Name = Utility.GetJobName(m_strAppID,m_strEnterpriseID,JobType.InvoiceGenerationJob);
					invJobBatch.Start();
					Hashtable appThreads = (Hashtable)context.Application["APP_THREADS"];

					if(appThreads != null)
					{
						appThreads[invJobBatch.Name] = invJobBatch;
					}

					//Commit the transaction
					transactionApp.Commit();
				}
			}
			catch(ApplicationException appException)
			{
				
				try
				{
					transactionApp.Rollback();
					Logger.LogTraceInfo("InvoiceJobMgrBAL","AllocateInvoiceJob","SDM002","App db delete transaction rolled back.");
				}
				catch(Exception rollbackException)
				{
					Logger.LogTraceError("InvoiceJobMgrBAL","AllocateInvoiceJob","SDM002","Error during app transanction roll back "+ rollbackException.Message.ToString());
				}

				//Logger.LogTraceError("InvoiceJobMgrBAL","AllocateInvoiceJob","SDM002","Delete Transaction Failed : "+ appException.Message.ToString());
				throw new ApplicationException(appException.Message,appException);
			}
			catch(Exception exception)
			{
				try
				{
					transactionApp.Rollback();
					Logger.LogTraceInfo("InvoiceJobMgrBAL","AllocateInvoiceJob","SDM002","App db delete transaction rolled back.");

				}
				catch(Exception rollbackException)
				{
					Logger.LogTraceError("InvoiceJobMgrBAL","AllocateInvoiceJob","SDM002","Error during app transanction roll back "+ rollbackException.Message.ToString());
				}
				throw new ApplicationException(exception.Message,exception);
			}
			finally
			{
				if(conApp != null)
				{
					conApp.Close();
				}
			}

			return m_jobStatusInfo;
		}

		private void Allocate()
		{
			try
			{
				Logger.LogDebugInfo("InvoiceJobMgrBAL","Allocate","INVJ001","Invoice GenerationThread started : ");

				DataSet dsInvShip = null;
				try
				{
					dsInvShip = InvoiceGenerationMgrDAL.GetInvoiceableShipments(m_strAppID, m_strEnterpriseID, m_dsInvoiceCriteria);
					CalculateCharges(dsInvShip);
				}
				catch(ApplicationException appException)
				{
					throw new ApplicationException(appException.Message,appException);
				}

				//get the invoice generation status from struc and form a message
				String strMsg = "";
				strMsg = strMsgCom;
				strMsg += " ";
				strMsg += strMsgTot;
				strMsg += " ";
				strMsg += m_invoiceStatusInfo.iInvoiceCount.ToString()+"/";
				strMsg += m_invoiceStatusInfo.iCustomerCount.ToString()+"/";
				strMsg += m_invoiceStatusInfo.iWayBillCount.ToString()+".";

				//Set the status in Invoice_Generation_Task table as Completed. Also put end_datetime
				InvoiceJobMgrDAL.UpdateInvoiceJobStatus(m_strAppID,m_strEnterpriseID,m_jobStatusInfo.iJobID,DateTime.Now,"C",strMsg);
	
			}
			catch(ApplicationException appException)
			{
				String strMsg = "";
				Logger.LogTraceError("InvoiceJobMgrBAL","Allocate","SDM002", "Error in Invoice Generation Thread : "+ appException.Message.ToString());
				if(appException.Message.IndexOf("Thread was being aborted") != -1)
				{
					strMsg = "Invoice Generation Job was aborted.";
				}
				else
				{
					strMsg = appException.Message;
				}

				InvoiceJobMgrDAL.UpdateInvoiceJobStatus(m_strAppID,m_strEnterpriseID,m_jobStatusInfo.iJobID,DateTime.Now,"E",strMsg);
			}
			catch(ThreadAbortException threadAbortException)
			{
				String strMsg = "Invoice Generation Job was aborted.";
				Logger.LogTraceError("InvoiceJobMgrBAL","Allocate","SDM002", "Thread Aborted : "+ threadAbortException.Message.ToString());
				InvoiceJobMgrDAL.UpdateInvoiceJobStatus(m_strAppID,m_strEnterpriseID,m_jobStatusInfo.iJobID,DateTime.Now,"E",strMsg);
			}
			catch(Exception exception)
			{
				Logger.LogTraceError("MCAJobMgrBAL","Allocate","SDM004","Error in MCA Thread : "+ exception.Message);
				InvoiceJobMgrDAL.UpdateInvoiceJobStatus(m_strAppID,m_strEnterpriseID,m_jobStatusInfo.iJobID,DateTime.Now,"E",exception.Message);
			}
		}

		public void CalculateCharges(DataSet dsIShip)
		{
			//array for batch execution of queries
			ArrayList queryList = new ArrayList();

			//variable misc
			int intRowsInserted=0, intCustomerCnt=0, intAWBCnt=0;
			int i=0, intCnt=0;

			intCnt = dsIShip.Tables[0].Rows.Count;
			//intCnt = 10;
			if (intCnt > 0)
			{
				try
				{
					//invoice header variables
					string strPrevPayType=null, strPrevPayID=null, strInvoiceNo=null, strInvoiceStatus=null;
					string strInvoiceDate=null, strDueDate=null;
					string strPayerId=null, strPayerType=null, strPayerName=null, strPayerAdd1=null, strPayerAdd2=null;
					string strPayerZip=null, strPayerCountry=null, strPayerTel=null, strPayerFax=null, strPayMode=null;
					int intCreditTerm=0, intInvDetInserted=0;
					DateTime dtInvoiceDate=DateTime.Now, dtDueDate=DateTime.Now;
					StringBuilder strBuilder = null;
					PODDetails podDetails;

					//invoice detail variables
					string strConsgNo=null, strRefNo=null, strOriState=null, strDesState=null, strRecName=null, strRecAdd1=null;
					string strRecAdd2=null, strRecZip=null, strRecCountry=null, strSenName=null, strSenAdd1=null, strSenAdd2=null;
					string strSenZip=null, strSenCountry=null, strMBG=null, strServiceCode=null; //, strPODExcep=null, strPerInCharge=null;
					string strBookingDate=null, strInvDetailQry=null; //, strPODRemark=null;
					int intTotPkg=0, intBookingNo=0, intArrayIndex=0;
					decimal decTotWt=0, decTotDimWt=0, decCharWt=0, decInsAmt=0, decTotFrgCharge=0, decTotVasSurcharge=0, decEsaSurcharge=0;
					decimal decInvoiceAmt=0, decInvSurchargeAmt=0;
					DateTime dtBookingDate;//, dtPODDate;

					//dataset for invoice summary 
					DataSet dsInvSumm=null;
					CreateInvSumDS(ref dsInvSumm);
					//UpdateInvSumDS(ref dsInvSumm,"S","INS",5,0);
					//UpdateInvSumDS(ref dsInvSumm,"I","INS",0,30);
					//return 0;

					for(i=0;i<intCnt;i++)
					{
						DataRow drEachShip = dsIShip.Tables[0].Rows[i];
						strPayerId = (string)drEachShip["payerid"];
						strPayerType = (string)drEachShip["payer_type"];
						if (strPrevPayType==null || strPrevPayType!=strPayerType || strPrevPayID==null || strPrevPayID!=strPayerId)
						{
							if (intRowsInserted > 0)
							{
								try
								{
									//call the method to run sql statements for invoice_summary table
									UpdateInvSumTab(ref dsInvSumm, strInvoiceNo, ref queryList);
								}
								catch(ApplicationException appException)
								{
									throw new ApplicationException(appException.Message,appException);
								}
							}

							strPrevPayID = strPayerId;
							strPrevPayType = strPayerType;
							strInvoiceNo = ""; strInvoiceDate = ""; strDueDate = ""; strInvoiceStatus = ""; strPayerName = ""; strPayerAdd1 = ""; strPayerAdd2 = "";
							strPayerZip = ""; strPayerCountry = ""; strPayerTel = ""; strPayerFax = ""; strPayMode = "";
							intCreditTerm = 0; intInvDetInserted=0;
							dtInvoiceDate=DateTime.Now; dtDueDate=DateTime.Now;

							//generate a new invoice no and insert into invoice header table
							strInvoiceNo = (string)Counter.GetNext(m_strAppID,m_strEnterpriseID,"invoice_number","INV");
							if (strPayerType == "C")
							{
								strPayMode = (string)drEachShip["payment_mode"];
								if ((drEachShip["customer_credit_term"]!=null) && (!drEachShip["customer_credit_term"].GetType().Equals(System.Type.GetType("System.DBNull"))))
									intCreditTerm = Convert.ToInt32(drEachShip["customer_credit_term"]);
							}
							else
							{
								strPayMode = (string)drEachShip["payment_mode"];
								if ((drEachShip["agent_credit_term"]!=null) && (!drEachShip["agent_credit_term"].GetType().Equals(System.Type.GetType("System.DBNull"))))
									intCreditTerm = Convert.ToInt32(drEachShip["agent_credit_term"]);
							}
							strInvoiceDate = Utility.DateFormat(m_strAppID, m_strEnterpriseID, dtInvoiceDate, DTFormat.DateTime);
							if (strPayMode == "R")
								dtDueDate = dtDueDate.AddDays(intCreditTerm);
							strDueDate = Utility.DateFormat(m_strAppID, m_strEnterpriseID, dtDueDate, DTFormat.DateTime);

							strBuilder = new StringBuilder();
							strBuilder.Append("insert into invoice (applicationid, enterpriseid, invoice_no, invoice_date, due_date, payerid, payer_type, payer_name, ");
							strBuilder.Append("payer_address1, payer_address2, payer_zipcode, payer_country, payer_telephone, payer_fax, payment_mode, jobid, invoice_status) values (");
							strBuilder.Append("'"+m_strAppID+"', '"+m_strEnterpriseID+"', '"+strInvoiceNo+"', "+strInvoiceDate+", "+strDueDate+", '"+strPayerId+"', '"+strPayerType+"', ");

							if ((drEachShip["payer_name"]!=null) && (!drEachShip["payer_name"].GetType().Equals(System.Type.GetType("System.DBNull"))))
							{
								strPayerName = (string)drEachShip["payer_name"];
								strBuilder.Append("N'"+Utility.ReplaceSingleQuote(strPayerName)+"', ");
							}
							else
								strBuilder.Append("null, ");

							if ((drEachShip["payer_address1"]!=null) && (!drEachShip["payer_address1"].GetType().Equals(System.Type.GetType("System.DBNull"))))
							{
								strPayerAdd1 = (string)drEachShip["payer_address1"];
								strBuilder.Append("N'"+Utility.ReplaceSingleQuote(strPayerAdd1)+"', ");
							}
							else
								strBuilder.Append("null, ");

							if ((drEachShip["payer_address2"]!=null) && (!drEachShip["payer_address2"].GetType().Equals(System.Type.GetType("System.DBNull"))))
							{
								strPayerAdd2 = (string)drEachShip["payer_address2"];
								strBuilder.Append("N'"+Utility.ReplaceSingleQuote(strPayerAdd2)+"', ");
							}
							else
								strBuilder.Append("null, ");

							if ((drEachShip["payer_zipcode"]!=null) && (!drEachShip["payer_zipcode"].GetType().Equals(System.Type.GetType("System.DBNull"))))
							{
								strPayerZip = (string)drEachShip["payer_zipcode"];
								strBuilder.Append("'"+strPayerZip+"', ");
							}
							else
								strBuilder.Append("null, ");

							if ((drEachShip["payer_country"]!=null) && (!drEachShip["payer_country"].GetType().Equals(System.Type.GetType("System.DBNull"))))
							{
								strPayerCountry = (string)drEachShip["payer_country"];
								strBuilder.Append("'"+strPayerCountry+"', ");
							}
							else
								strBuilder.Append("null, ");

							if ((drEachShip["payer_telephone"]!=null) && (!drEachShip["payer_telephone"].GetType().Equals(System.Type.GetType("System.DBNull"))))
							{
								strPayerTel = (string)drEachShip["payer_telephone"];
								strBuilder.Append("'"+Utility.ReplaceSingleQuote(strPayerTel)+"', ");
							}
							else
								strBuilder.Append("null, ");

							if ((drEachShip["payer_fax"]!=null) && (!drEachShip["payer_fax"].GetType().Equals(System.Type.GetType("System.DBNull"))))
							{
								strPayerFax = (string)drEachShip["payer_fax"];
								strBuilder.Append("'"+Utility.ReplaceSingleQuote(strPayerFax)+"', ");
							}
							else
								strBuilder.Append("null, ");

							strInvoiceStatus = "U";
							strBuilder.Append("'");
							strBuilder.Append(strPayMode);
							strBuilder.Append("',");
							strBuilder.Append(m_jobStatusInfo.iJobID);
							strBuilder.Append(", '");
							strBuilder.Append(strInvoiceStatus);
							strBuilder.Append("')");

							//insert into invoice header table
							try
							{
								//intRowsInserted += InvoiceGenerationMgrDAL.InsertInvoiceHeader(m_strAppID, m_strEnterpriseID, strBuilder.ToString());
								queryList.Add(strBuilder.ToString());
								intRowsInserted++;
								intCustomerCnt++;
							}
							catch(ApplicationException appException)
							{
								throw new ApplicationException(appException.Message,appException);
							}
						}

						//insert into invoice detail tables
						strConsgNo=null; strRefNo=null; strOriState=null; strDesState=null; strRecName=null; strRecAdd1=null;
						strRecAdd2=null; strRecZip=null; strRecCountry=null; strSenName=null; strSenAdd1=null; strSenAdd2=null;
						strSenZip=null; strSenCountry=null; strMBG=null; strServiceCode=null; //strPODExcep=null; strPerInCharge=null;
						strBookingDate=null; strInvDetailQry=null; //strPODRemark=null;
						intTotPkg=0; decTotWt=0; decTotDimWt=0; decCharWt=0; decInsAmt=0; decTotFrgCharge=0; decTotVasSurcharge=0; 
						intBookingNo=0; decEsaSurcharge=0; decInvoiceAmt=0; decInvSurchargeAmt=0; intArrayIndex=0;//dtBookingDate; dtPODDate;

						//StringBuilder strBuilder = new StringBuilder();
						strBuilder = new StringBuilder();
						podDetails = new PODDetails();
						strBuilder.Append("insert into invoice_detail (applicationid, enterpriseid, invoice_no, consignment_no, booking_datetime, ");
						strBuilder.Append("ref_no, origin_state_code, destination_state_code, tot_pkg, tot_wt, tot_dim_wt, chargeable_wt, recipient_name, ");
						strBuilder.Append("recipient_address1, recipient_address2, recipient_zipcode, recipient_country, sender_name, sender_address1, ");
						strBuilder.Append("sender_address2, sender_zipcode, sender_country, service_code, pod_datetime, pod_exception, person_incharge, ");
						strBuilder.Append("pod_remark, insurance_amt, tot_freight_charge, tot_vas_surcharge, esa_surcharge, invoice_amt, mbg) values (");
						strBuilder.Append("'"+m_strAppID+"', '"+m_strEnterpriseID+"', '"+strInvoiceNo+"', ");

						strConsgNo = (string)drEachShip["consignment_no"];
						strBuilder.Append("'"+strConsgNo+"', ");

						//get booking no to join shipment_tracking table
						intBookingNo = Convert.ToInt32(drEachShip["booking_no"]);
						dtBookingDate = (DateTime)drEachShip["booking_datetime"];
						strBookingDate = Utility.DateFormat(m_strAppID, m_strEnterpriseID, dtBookingDate, DTFormat.DateTime);
						strBuilder.Append(strBookingDate+", ");

						if ((drEachShip["ref_no"]!=null) && (!drEachShip["ref_no"].GetType().Equals(System.Type.GetType("System.DBNull"))))
						{
							strRefNo = (string)drEachShip["ref_no"];
							strBuilder.Append("'"+strRefNo+"', ");
						}
						else
							strBuilder.Append("null, ");

						if ((drEachShip["origin_state_code"]!=null) && (!drEachShip["origin_state_code"].GetType().Equals(System.Type.GetType("System.DBNull"))))
						{
							strOriState = (string)drEachShip["origin_state_code"];
							strBuilder.Append("'"+Utility.ReplaceSingleQuote(strOriState)+"', ");
						}
						else
							strBuilder.Append("null, ");

						if ((drEachShip["destination_state_code"]!=null) && (!drEachShip["destination_state_code"].GetType().Equals(System.Type.GetType("System.DBNull"))))
						{
							strDesState = (string)drEachShip["destination_state_code"];
							strBuilder.Append("'"+Utility.ReplaceSingleQuote(strDesState)+"', ");
						}
						else
							strBuilder.Append("null, ");

						if ((drEachShip["tot_pkg"]!=null) && (!drEachShip["tot_pkg"].GetType().Equals(System.Type.GetType("System.DBNull"))))
							intTotPkg = Convert.ToInt32(drEachShip["tot_pkg"]);
						strBuilder.Append(intTotPkg+", ");

						if ((drEachShip["tot_wt"]!=null) && (!drEachShip["tot_wt"].GetType().Equals(System.Type.GetType("System.DBNull"))))
							decTotWt = Convert.ToDecimal(drEachShip["tot_wt"]);
						strBuilder.Append(decTotWt+", ");

						if ((drEachShip["tot_dim_wt"]!=null) && (!drEachShip["tot_dim_wt"].GetType().Equals(System.Type.GetType("System.DBNull"))))
							decTotDimWt = Convert.ToDecimal(drEachShip["tot_dim_wt"]);
						strBuilder.Append(decTotDimWt+", ");

						if ((drEachShip["chargeable_wt"]!=null) && (!drEachShip["chargeable_wt"].GetType().Equals(System.Type.GetType("System.DBNull"))))
							decCharWt = Convert.ToDecimal(drEachShip["chargeable_wt"]);
						strBuilder.Append(decCharWt+", ");

						if ((drEachShip["recipient_name"]!=null) && (!drEachShip["recipient_name"].GetType().Equals(System.Type.GetType("System.DBNull"))))
						{
							strRecName = (string)drEachShip["recipient_name"];
							strBuilder.Append("N'"+Utility.ReplaceSingleQuote(strRecName)+"', ");
						}
						else
							strBuilder.Append("null, ");

						if ((drEachShip["recipient_address1"]!=null) && (!drEachShip["recipient_address1"].GetType().Equals(System.Type.GetType("System.DBNull"))))
						{
							strRecAdd1 = (string)drEachShip["recipient_address1"];
							strBuilder.Append("N'"+Utility.ReplaceSingleQuote(strRecAdd1)+"', ");
						}
						else
							strBuilder.Append("null, ");

						if ((drEachShip["recipient_address2"]!=null) && (!drEachShip["recipient_address2"].GetType().Equals(System.Type.GetType("System.DBNull"))))
						{
							strRecAdd2 = (string)drEachShip["recipient_address2"];
							strBuilder.Append("N'"+Utility.ReplaceSingleQuote(strRecAdd2)+"', ");
						}
						else
							strBuilder.Append("null, ");

						if ((drEachShip["recipient_zipcode"]!=null) && (!drEachShip["recipient_zipcode"].GetType().Equals(System.Type.GetType("System.DBNull"))))
						{
							strRecZip = (string)drEachShip["recipient_zipcode"];
							strBuilder.Append("'"+strRecZip+"', ");
						}
						else
							strBuilder.Append("null, ");

						if ((drEachShip["recipient_country"]!=null) && (!drEachShip["recipient_country"].GetType().Equals(System.Type.GetType("System.DBNull"))))
						{
							strRecCountry = (string)drEachShip["recipient_country"];
							strBuilder.Append("'"+strRecCountry+"', ");
						}
						else
							strBuilder.Append("null, ");

						if ((drEachShip["sender_name"]!=null) && (!drEachShip["sender_name"].GetType().Equals(System.Type.GetType("System.DBNull"))))
						{
							strSenName = (string)drEachShip["sender_name"];
							strBuilder.Append("N'"+Utility.ReplaceSingleQuote(strSenName)+"', ");
						}
						else
							strBuilder.Append("null, ");

						if ((drEachShip["sender_address1"]!=null) && (!drEachShip["sender_address1"].GetType().Equals(System.Type.GetType("System.DBNull"))))
						{
							strSenAdd1 = (string)drEachShip["sender_address1"];
							strBuilder.Append("N'"+Utility.ReplaceSingleQuote(strSenAdd1)+"', ");
						}
						else
							strBuilder.Append("null, ");

						if ((drEachShip["sender_address2"]!=null) && (!drEachShip["sender_address2"].GetType().Equals(System.Type.GetType("System.DBNull"))))
						{
							strSenAdd2 = (string)drEachShip["sender_address2"];
							strBuilder.Append("N'"+Utility.ReplaceSingleQuote(strSenAdd2)+"', ");
						}
						else
							strBuilder.Append("null, ");

						if ((drEachShip["sender_zipcode"]!=null) && (!drEachShip["sender_zipcode"].GetType().Equals(System.Type.GetType("System.DBNull"))))
						{
							strSenZip = (string)drEachShip["sender_zipcode"];
							strBuilder.Append("'"+strSenZip+"', ");
						}
						else
							strBuilder.Append("null, ");

						if ((drEachShip["sender_country"]!=null) && (!drEachShip["sender_country"].GetType().Equals(System.Type.GetType("System.DBNull"))))
						{
							strSenCountry = (string)drEachShip["sender_country"];
							strBuilder.Append("'"+strSenCountry+"', ");
						}
						else
							strBuilder.Append("null, ");

						if (strPayerType == "C")
						{
							if ((drEachShip["customer_mbg"]!=null) && (!drEachShip["customer_mbg"].GetType().Equals(System.Type.GetType("System.DBNull"))))
							{
								strMBG = (string)drEachShip["customer_mbg"];
								m_mbg = strMBG;
								//strBuilder.Append("'"+strMBG+"', ");
							}
							//else
								//strBuilder.Append("'N', ");
						}
						else
						{
							if ((drEachShip["agent_mbg"]!=null) && (!drEachShip["agent_mbg"].GetType().Equals(System.Type.GetType("System.DBNull"))))
							{
								strMBG = (string)drEachShip["agent_mbg"];
								m_mbg = strMBG;
								//strBuilder.Append("'"+strMBG+"', ");
							}
							//else
								//strBuilder.Append("'N', ");
						}

						if ((drEachShip["service_code"]!=null) && (!drEachShip["service_code"].GetType().Equals(System.Type.GetType("System.DBNull"))))
						{
							strServiceCode = (string)drEachShip["service_code"];
							strServiceCode = strServiceCode.ToUpper();
							strBuilder.Append("'"+strServiceCode+"', ");
						}
						else
							strBuilder.Append("null, ");

						//get "POD_datetime", "POD_exception", "person_incharge" and "POD_remark" from shipment tracking table and
						//insert into respective columns of invoice_detail table 
						podDetails = ShipmentTrackingMgrDAL.GetEarliestPodDetails(m_strAppID, m_strEnterpriseID, strConsgNo, intBookingNo);
						if (Utility.IsNotDBNull(podDetails.PODDateTime))
						{
							strBuilder.Append(podDetails.PODDateTime);
							strBuilder.Append(", '");
							strBuilder.Append(podDetails.PODException);
							strBuilder.Append("', N'");
							strBuilder.Append(Utility.ReplaceSingleQuote(podDetails.PersonIncharge));
							strBuilder.Append("', N'");
							strBuilder.Append(Utility.ReplaceSingleQuote(podDetails.PODRemark));
							strBuilder.Append("', ");
						}
						else
							strBuilder.Append("null, null, null, null, ");

						if ((drEachShip["insurance_surcharge"]!=null) && (!drEachShip["insurance_surcharge"].GetType().Equals(System.Type.GetType("System.DBNull"))))
							decInsAmt = Convert.ToDecimal(drEachShip["insurance_surcharge"]);
						strBuilder.Append(decInsAmt+", ");

						if ((drEachShip["tot_freight_charge"]!=null) && (!drEachShip["tot_freight_charge"].GetType().Equals(System.Type.GetType("System.DBNull"))))
							decTotFrgCharge = Convert.ToDecimal(drEachShip["tot_freight_charge"]);
						strBuilder.Append(decTotFrgCharge+", ");

						if ((drEachShip["tot_vas_surcharge"]!=null) && (!drEachShip["tot_vas_surcharge"].GetType().Equals(System.Type.GetType("System.DBNull"))))
							decTotVasSurcharge = Convert.ToDecimal(drEachShip["tot_vas_surcharge"]);
						strBuilder.Append(decTotVasSurcharge+", ");

						if ((drEachShip["esa_surcharge"]!=null) && (!drEachShip["esa_surcharge"].GetType().Equals(System.Type.GetType("System.DBNull"))))
							decEsaSurcharge = Convert.ToDecimal(drEachShip["esa_surcharge"]);
						strBuilder.Append(decEsaSurcharge+", ");

						strInvDetailQry = strBuilder.ToString();
						//calculate invoice_amt
						//decInvoiceAmt = decTotFrgCharge+decInsAmt+decEsaSurcharge+decTotVasSurcharge;
						//strBuilder.Append(decInvoiceAmt+")");

						try
						{
							//create a index in array list for query string created to insert into invoice detail table
							intArrayIndex = queryList.Add("");
							intInvDetInserted++;

							//calculate invoice_status_exception surcharges
							decInvSurchargeAmt=CalculateSurcharge(strInvoiceNo, intBookingNo, strConsgNo, strPayerType, ref queryList);

							//calculate invoice_amt
							if (m_mbg == "Y" || m_mbg == "y")
								decInvoiceAmt = 0;
							else
							{
								decInvoiceAmt = decTotFrgCharge+decInsAmt+decEsaSurcharge+decTotVasSurcharge+decInvSurchargeAmt;
								decInvoiceAmt = Convert.ToDecimal(TIESUtility.Round_Enterprise_Currency(m_strAppID, m_strEnterpriseID, decInvoiceAmt));
							}
							strInvDetailQry += decInvoiceAmt+", '"+m_mbg+"')";
							//insert into invoice detail table
							queryList.RemoveAt(intArrayIndex);
							queryList.Insert(intArrayIndex, strInvDetailQry);

							intAWBCnt++;

							//generate/update invoice summary dataset
							UpdateInvSumDS(ref dsInvSumm,"S",strServiceCode,decCharWt,decTotFrgCharge);
							UpdateInvSumDS(ref dsInvSumm,"I","INS",decCharWt,decInsAmt);
							UpdateInvSumDS(ref dsInvSumm,"E","ESA",decCharWt,decEsaSurcharge);
							UpdateInvSumDS(ref dsInvSumm,"V","VAS",decCharWt,decTotVasSurcharge);
							UpdateInvSumDS(ref dsInvSumm,"X","S&E",decCharWt,decInvSurchargeAmt);
							if (m_mbg == "Y" || m_mbg == "y")
								UpdateInvSumDS(ref dsInvSumm,"M","MBG",decCharWt,(decTotFrgCharge+decInsAmt+decEsaSurcharge+decTotVasSurcharge+decInvSurchargeAmt));

							//update shipment table
							//InvoiceGenerationMgrDAL.UpdateShipment(m_strAppID, m_strEnterpriseID, intBookingNo, strConsgNo, strInvoiceNo, strInvoiceDate, decInvoiceAmt);
							strBuilder = new StringBuilder();
							strBuilder.Append("Update shipment set invoice_no = '");
							strBuilder.Append(strInvoiceNo);
							strBuilder.Append("', invoice_date = ");
							strBuilder.Append(strInvoiceDate);
							strBuilder.Append(", invoice_amt = ");
							strBuilder.Append(decInvoiceAmt);
							strBuilder.Append(" where applicationid = '");
							strBuilder.Append(m_strAppID);
							strBuilder.Append("' and enterpriseid = '");
							strBuilder.Append(m_strEnterpriseID);
							strBuilder.Append("' and booking_no = ");
							strBuilder.Append(intBookingNo);
							strBuilder.Append(" and consignment_no = '");
							strBuilder.Append(strConsgNo);
							strBuilder.Append("'");
							queryList.Add(strBuilder.ToString());
						}
						catch(ApplicationException appException)
						{
							throw new ApplicationException(appException.Message,appException);
						}
						if (i==(intCnt-1))
						{
							try
							{
								//call the method to run sql statements for invoice_summary table
								UpdateInvSumTab(ref dsInvSumm, strInvoiceNo, ref queryList);
							}
							catch(ApplicationException appException)
							{
								throw new ApplicationException(appException.Message,appException);
							}
						}
						//end of for loop
					}
					//end of if statement 
				}
				catch(ApplicationException appException)
				{
					throw new ApplicationException(appException.Message,appException);
				}

				//update into database from querylist using batch transaction method
				if (queryList.Count > 0)
				{
					DbConnection dbConInv = DbConnectionManager.GetInstance().GetDbConnection(m_strAppID, m_strEnterpriseID);
					if(dbConInv == null)
					{
						Logger.LogTraceError("InvoiceJobMgrBAL","CalculateCharges","EDB101","DbConnection object is null!!");
					}
					try
					{
						dbConInv.ExecuteBatchSQLinTranscation(queryList);
					}
					catch(ApplicationException appException)
					{
						throw new ApplicationException(appException.Message,appException);
					}
				}
				else
				{
					intRowsInserted=0; intCustomerCnt=0; intAWBCnt=0;
				}
			}

			m_invoiceStatusInfo.iInvoiceCount = intRowsInserted;
			m_invoiceStatusInfo.iCustomerCount = intCustomerCnt;
			m_invoiceStatusInfo.iWayBillCount = intAWBCnt;
			return;
		}

		public decimal CalculateSurcharge(string strInvoiceNo, int intBookNo, string strConsignmentNo, string strPayerType, ref ArrayList queryList)
		{
			DataSet dsInvSurcharge=null;
			int intSurCnt=0, i=0, intRowsIns=0;
			string strStatusCode=null, strExceptionCode=null, strMBGExcep="N";
			decimal decSurcharge=0, decTotSur=0;
			StringBuilder strBuilder = null;
			dsInvSurcharge = InvoiceGenerationMgrDAL.GetInvoiceableSurcharges(m_strAppID, m_strEnterpriseID, intBookNo, strConsignmentNo);
			intSurCnt = dsInvSurcharge.Tables[0].Rows.Count;
			if (intSurCnt == 0) 
				m_mbg = "N";
			for(i=0;i<intSurCnt;i++)
			{
				strStatusCode=null; strExceptionCode=null; decSurcharge=0; //decTotSur=0;
				DataRow drEachShip = dsInvSurcharge.Tables[0].Rows[i];

				//check for mbg flag for status&exception table at least 1 exception should be mbg flag=y
				if (strMBGExcep == "N")
				{
					//checking money back gaurantee from shipment tracking table
					if (m_mbg == "Y" || m_mbg == "y")
					{
						if (Utility.IsNotDBNull(drEachShip["mbg"]))
						{
							if (drEachShip["mbg"].ToString() == "Y" || drEachShip["mbg"].ToString() == "y")
								strMBGExcep = "Y";
						}
					}
				}

				if ((drEachShip["surcharge"]!=null) && (!drEachShip["surcharge"].GetType().Equals(System.Type.GetType("System.DBNull"))))
					decSurcharge = Convert.ToDecimal(drEachShip["surcharge"]);

				if (decSurcharge > 0)
				{
					decTotSur += decSurcharge;
					strStatusCode = (string)drEachShip["status_code"];
					if ((drEachShip["exception_code"]!=null) && (!drEachShip["exception_code"].GetType().Equals(System.Type.GetType("System.DBNull"))))
						strExceptionCode = (string)drEachShip["exception_code"];
					else
						strExceptionCode = " ";

					strBuilder = new StringBuilder();
					strBuilder.Append("insert into invoice_status_exception (applicationid, enterpriseid, invoice_no, consignment_no, status_code, ");
					strBuilder.Append("exception_code, surcharge) values (");
					strBuilder.Append("'"+m_strAppID+"', '"+m_strEnterpriseID+"', '"+strInvoiceNo+"', '"+strConsignmentNo+"', '"+strStatusCode+"', ");
					strBuilder.Append("'"+strExceptionCode+"', "+decSurcharge+")");
					try
					{
						//intRowsIns += InvoiceGenerationMgrDAL.InsertInvoiceHeader(m_strAppID, m_strEnterpriseID, strBuilder.ToString());
						queryList.Add(strBuilder.ToString());
						intRowsIns++;
					}
					catch(ApplicationException appException)
					{
						throw new ApplicationException(appException.Message,appException);
					}
				}
			}
			m_mbg = strMBGExcep;
			return decTotSur;
		}

		private void CreateInvSumDS(ref DataSet dsInvSumm)
		{
			DataTable dtInvSumm = new DataTable();
			dtInvSumm.Columns.Add(new DataColumn("summary_type", typeof(string)));
			dtInvSumm.Columns.Add(new DataColumn("summary_code", typeof(string)));
			dtInvSumm.Columns.Add(new DataColumn("tot_consignment", typeof(int)));
			dtInvSumm.Columns.Add(new DataColumn("tot_chargeable_wt", typeof(decimal)));
			dtInvSumm.Columns.Add(new DataColumn("invoice_amt", typeof(decimal)));

			/*DataRow drEach = dtInvSumm.NewRow();
			drEach["summary_type"] = "S";
			drEach["summary_code"] = "SVC";
			drEach["tot_consignment"] = 1;
			drEach["tot_chargeable_wt"] = 10;
			drEach["invoice_amt"] = 100;
			dtInvSumm.Rows.Add(drEach);*/

			dsInvSumm = new DataSet();
			dsInvSumm.Tables.Add(dtInvSumm);
		}

		private void UpdateInvSumDS(ref DataSet dsInvSumm, string strSummType, string strSummCode, decimal decCharWT, decimal decInvAmt)
		{
			int intDSCnt = dsInvSumm.Tables[0].Rows.Count;
			bool bFound=false;
			int intRowIndex=0, intTotConsg=0;
			decimal decChargeableWt=0, decInvoiceAmt=0;
			if (decInvAmt<1)
				return;

			for (int j=0;j<intDSCnt;j++)
			{
				DataRow drEachSumm = dsInvSumm.Tables[0].Rows[j];
				string strSummaryType = (string)drEachSumm["summary_type"];
				if (strSummaryType.Equals(strSummType))
				{
					string strSummaryCode = (string)drEachSumm["summary_code"];
					if (strSummaryCode.Equals(strSummCode))
					{
						bFound=true;
						intRowIndex=j;
						break;
					}
				}
			}
			if (bFound==true)
			{
				//update dataset
				DataRow dr = dsInvSumm.Tables[0].Rows[intRowIndex];
				intTotConsg = (Convert.ToInt32(dr["tot_consignment"])) + 1;
				dr["tot_consignment"] = intTotConsg;
				if (decCharWT > 0)
				{
					decChargeableWt = (Convert.ToDecimal(dr["tot_chargeable_wt"])) + decCharWT;
					dr["tot_chargeable_wt"] = decChargeableWt;
				}
				if (decInvAmt > 0)
				{
					decInvoiceAmt = (Convert.ToDecimal(dr["invoice_amt"])) + decInvAmt;
					dr["invoice_amt"] = decInvoiceAmt;
				}
				dsInvSumm.Tables[0].Rows[intRowIndex].AcceptChanges();
			}
			else
			{
				//insert dataset
				DataRow dr = dsInvSumm.Tables[0].NewRow();
				dr["summary_type"] = strSummType;
				dr["summary_code"] = strSummCode;
				dr["tot_consignment"] = 1;
				dr["tot_chargeable_wt"] = decCharWT;
				dr["invoice_amt"] = decInvAmt;
				dsInvSumm.Tables[0].Rows.Add(dr);
			}
			int intChk = dsInvSumm.Tables[0].Rows.Count;
			return;
		}

		private void UpdateInvSumTab(ref DataSet dsInvSumm, string strInvoiceNo, ref ArrayList queryList)
		{
			int intRowCnt=dsInvSumm.Tables[0].Rows.Count;
			StringBuilder strBuilder = null;
			if (intRowCnt<1)
				return;

			for (int k=0;k<intRowCnt;k++)
			{
				DataRow dr = dsInvSumm.Tables[0].Rows[k];
				string strSummType = (string)dr["summary_type"];
				string strSummCode = (string)dr["summary_code"];
				int intTotConsg = Convert.ToInt32(dr["tot_consignment"]);
				decimal decCharWt = Convert.ToDecimal(dr["tot_chargeable_wt"]);
				decimal decInvAmt = 0;
				if (strSummType == "M")
					decInvAmt -= Convert.ToDecimal(dr["invoice_amt"]);
				else
					decInvAmt = Convert.ToDecimal(dr["invoice_amt"]);
				strBuilder = new StringBuilder();
				strBuilder.Append("insert into invoice_summary (applicationid, enterpriseid, invoice_no, summary_code_type, summary_code, ");
				strBuilder.Append("tot_consignment, tot_chargeable_wt, invoice_amt,sequence) values ('"+m_strAppID+"', '"+m_strEnterpriseID+"', '"+strInvoiceNo+"', ");
				strBuilder.Append("'"+strSummType+"', '"+strSummCode+"', "+intTotConsg+", "+decCharWt+", "+decInvAmt+",null)");
				try
				{
					//InvoiceGenerationMgrDAL.InsertInvoiceHeader(m_strAppID, m_strEnterpriseID, strBuilder.ToString());
					queryList.Add(strBuilder.ToString());
				}
				catch(ApplicationException appException)
				{
					throw new ApplicationException(appException.Message,appException);
				}
			}
			dsInvSumm.Tables[0].Rows.Clear();
			return;
		}

	}
}
